#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "close4xi.py">
#<abstract4xi abstract = "providing function close4xi"/>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'close4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading
try:
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>
     
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "close4xi" usage = "
#   forking.py:
#       close = os.close
#   _serve4xi.py:
#       close4xi(handle_wanted2xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def close4xi(handle):
    '''
    closes handle trying both _winapi.CloseHandle and os.close
    '''
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/5)
    # ---------------------------------------------------------------------------------------------   
    class2print = 'close4xi'
    method2print = 'close4xi'

    message2print = "{(Step 1/5a) started" + "; close4xi-started: " + str(close4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            

    message2print = "{(Step 1/5b) passed" + "; handle-passed-to-close4xi: " + str(handle) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #HW: 244        
            
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/5)
    # ---------------------------------------------------------------------------------------------   
    close = _winapi.CloseHandle    
    
    message2print = "{(Step 2/5) set" + "; close-set-by-close4xi to: " + str(close)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #HW: <built-in function CloseHandle>    
        
    try:
        # ---------------------------------------------------------------------------------------------    
        # (Step 3/5)
        # ---------------------------------------------------------------------------------------------      
        
        message2print = "{(Step 3/5a) passing" + "; handle-passing-to-_winapi.CloseHandle-by-close4xi: " + str(handle) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
         

        _winapi.CloseHandle(handle)  
        
        message2print = "{(Step 3/5b) performed" + "; _winapi.CloseHandle-performed-by-close4xi: " + str(_winapi.CloseHandle) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        #HW: <built-in function CloseHandle>
                
    except:
        # ---------------------------------------------------------------------------------------------    
        # (Step 4/5)
        # ---------------------------------------------------------------------------------------------      
        message2print = "{(Step 4/5a) yielded" + "; _winapi.CloseHandle-yielded-by-close4xi: " + str(_winapi.CloseHandle)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
 
        try:

            message2print = "{(Step 4/5b) passing" + "; handle-passing-to-os-close-by-close4xi: " + str(handle) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
             
            os.close(handle)
    
            message2print = "{(Step 4/5c) performed" + "; os-close-performed-by-close4xi: " + str(os.close) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
        except:
            message2print = "{(Step 4/5d) hit" + "; os-error-hit-by-close4xi, handle = " + " *** " + str(handle)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
        
    # ---------------------------------------------------------------------------------------------    
    # (Step 5/5)
    # ---------------------------------------------------------------------------------------------   
    
    message2print = "{returning" + "; close4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      


#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of close4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
